<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelDailyContracts ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelDailyContracts extends AbstractStructArrayBase
{
    /**
     * The DailyContracts
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelDailyContracts[]
     */
    public $DailyContracts;
    /**
     * Constructor method for ArrayOfJP_HotelDailyContracts
     * @uses ArrayOfJP_HotelDailyContracts::setDailyContracts()
     * @param \StructType\JP_HotelDailyContracts[] $dailyContracts
     */
    public function __construct(array $dailyContracts = array())
    {
        $this
            ->setDailyContracts($dailyContracts);
    }
    /**
     * Get DailyContracts value
     * @return \StructType\JP_HotelDailyContracts[]|null
     */
    public function getDailyContracts()
    {
        return $this->DailyContracts;
    }
    /**
     * Set DailyContracts value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelDailyContracts[] $dailyContracts
     * @return \ArrayType\ArrayOfJP_HotelDailyContracts
     */
    public function setDailyContracts(array $dailyContracts = array())
    {
        foreach ($dailyContracts as $arrayOfJP_HotelDailyContractsDailyContractsItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelDailyContractsDailyContractsItem instanceof \StructType\JP_HotelDailyContracts) {
                throw new \InvalidArgumentException(sprintf('The DailyContracts property can only contain items of \StructType\JP_HotelDailyContracts, "%s" given', is_object($arrayOfJP_HotelDailyContractsDailyContractsItem) ? get_class($arrayOfJP_HotelDailyContractsDailyContractsItem) : gettype($arrayOfJP_HotelDailyContractsDailyContractsItem)), __LINE__);
            }
        }
        $this->DailyContracts = $dailyContracts;
        return $this;
    }
    /**
     * Add item to DailyContracts value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelDailyContracts $item
     * @return \ArrayType\ArrayOfJP_HotelDailyContracts
     */
    public function addToDailyContracts(\StructType\JP_HotelDailyContracts $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelDailyContracts) {
            throw new \InvalidArgumentException(sprintf('The DailyContracts property can only contain items of \StructType\JP_HotelDailyContracts, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DailyContracts[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelDailyContracts|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelDailyContracts|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelDailyContracts|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelDailyContracts|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelDailyContracts|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DailyContracts
     */
    public function getAttributeName()
    {
        return 'DailyContracts';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelDailyContracts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
